QGIS Application - Bug report #11399
Unable to add raster and vector files via drag and drop on OS X 10.10
2014-10-13 09:45 AM - david dellatore

Status: Closed

Priority: Normal

Assignee: Larry Shaffer

Category: Browser

Affected QGIS version:2.4.0 Regression?: No
Operating System: OSX, WIN8.1 Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 19681
Description

| have a clean install of OSx Yosemite Beta 5, with homebrew install of QGIS 2.4 and all its basic dependencies.

-QGIS version 2.4.0-Chugiak

-QGIS code revision exported -Compiled against Qt 4.8.6

-Running against Qt 4.8.6 -Compiled against GDAL/OGR 1.11.1

-Running against GDAL/OGR 1.11.1 -Compiled against GEOS 3.4.2-CAPI-1.8.2
-Running against GEOS 3.4.2-CAPI-1.8.2 r3921 -PostgreSQL Client Version 9.3.5
-SpatiaL.ite Version 4.2.0 -QWT Version 6.1.1

-PROJ.4 Version 480 -QScintilla2 Version 2.8.3

Am able to load QGIS with no errors thrown, and can view shapefiles, connect to postgres, etc, but can only add new shapefiles if done
through the 'Layer - Add Vector Layer' workflow. Dragging and dropping into QGIS results in:

'Invalid Data Source:/.file/id=6571367..... is not a valid or recognized data source

| am also unable to use SPIT to import shapefiles into postgres:
Problem inserting features from file:/xxxxx/xx.shp

Am trying to migrate from just using arcgis, so any help would be greatly appreciated.

This was reported by another user in August 2014 (
https://gis.stackexchange.com/questions/111668/qgis-2-4-0-mac-yosemite-compatibility), and is still an issue now.

Thank you

Associated revisions

Revision 220affbf - 2015-10-23 10:26 AM - Larry Shaffer

Fix #11399; fix up Mac OS X 10.10+ dropped file URLs

History

#1 - 2014-10-19 03:14 AM - Anita Graser

The path to the file looks very fishy, especially with the = sign ...

/ file/id=6571367

Have you tried moving the files to a clean path like /home/temp?
https://gis.stackexchange.com/questions/111668/qgis-2-4-0-mac-yosemite-compatibility

#2 - 2014-10-19 03:58 AM - david dellatore

Greetings and thank you for the response.

I have tried moving files (which were in dropbox folder) to the desktop, to my home directory, and to /home/public, all with the same result with drag/drop:

Invalid Data Source: /.file/id=6571367.3678663 is not a valid or recognized data source

However when double clicking the same .shp from the finder, the files open up fine in QGIS - so that the functionality is partly there, but still something

missing.

The path to the file looks very fishy, especially with the = sign ...

/.file/id=6571367

Have you tried moving the files to a clean path like /home/temp?

#3 - 2014-10-19 04:18 AM - david dellatore
- File Screen_Shot _2014-10-19_at 13.15.36.png added

Just for info - have tried installing qgis-22, and the same error remains. Have attached a screenshot for context.

#4 - 2014-10-20 08:16 AM - John Tull

This issue exists in trunk also. It has been present for some time. | was just looking to post a bug report, but this bug covers it.

To summarize, the browser in qgis works fine for adding files. Double-clicking a shapefile in the Finder will add it to qgis. Using the 'Add vector layer..."

menu item and browsing to your file will work. Dragging a shapefile (or any suitable raster or vector layer) results in an error, "Invalid data source ...".
My OS X version is 10.10, had the problem during beta testing of 10.10 also. | do not recall if this issue existed on 10.9.

#5 - 2014-10-20 08:17 AM - John Tull

- Target version set to Version 2.6

- Operating System set to OSX

#6 - 2014-10-31 05:55 AM - Jiirgen Fischer
- Target version changed from Version 2.6 to Future Release - High Priority

#7 - 2014-11-04 08:41 AM - John Tull
- Subject changed from Unable to add shapefiles via drag and drop to Unable to add raster and vector files via drag and drop on OS X 10.10
| updated the title of this bug to properly reflect the greater issue, i.e., the inability to load both vector and raster files via drag and drop on OS X 10.10. If

others with older OS versions can confirm this issue is not specific to Yosemite (10.10), please update the title.

Here is further information on this as it has been documented in the Qt bug tracker:
https://bugreports.qgt-project.org/browse/QTBUG-40449

Perhaps a solution lies therein?

#8 - 2015-01-13 01:24 AM - Benoit de Cabissole
- Operating System changed from OSX to OSX, WIN8.1

Also happens on Dev. versions since at least beginning of December 2014, on Windows 8.1.

#9 - 2015-06-08 08:04 PM - Larry Shaffer

Hi,

This can be fixed for Qt 4.8.x, but requires direct access to the Cocoa AP when needed to introduce the workarounds noted in the QTBUG-40449.

Btw, this is an example of my old PR to introduce abstracted calls to the OS (Mac for example, with Objective-C++) to handle changes in OS APl libraries
and keep such workarounds in one place instead of peppered throughout the source tree.

| suppose the same could be done for Win as well.

#10 - 2015-10-07 10:03 AM - John Tull

The references gt bug has a comment from Aug 2015 with the following workaround code that should work with recent qt4. Perhaps this can be worked
into qgis code to fix this issue that is quite the show-stopper on OS X:

QString localFileQString = url.toLocalFile();
/I [pzion 20150805] Work around
/I https://bugreports.qt.io/browse/QTBUG-40449
if ( localFileQString.startsWith("/ file/id=") )
{
CFStringRef relCFStringRef =
CFStringCreateWithCString(
kCFAllocatorDefault,
localFileQString.toUtf8().constData(),
kCFStringEncodingUTF8
);
CFURLRef relCFURL =
CFURLCreateWithFileSystemPath(
kCFAllocatorDefault,
relCFStringRef,
kCFURLPOSIXPathStyle,
false // isDirectory
);
CFErrorRef error = 0;
CFURLRef absCFURL =
CFURLCreateFilePathURL(
kCFAllocatorDefault,
relCFURL,
&error
);
if (lerror)
{
static const CFIndex maxAbsPathCStrBufLen = 4096;
char absPathCStr[maxAbsPathCStrBufLen];
if ( CFURLGetFileSystemRepresentation(
absCFURL,
true, // resolveAgainstBase
reinterpret_cast<UInt8 *>( &absPathCStr[0] ),
maxAbsPathCStrBufLen
))
{
localFileQString = QString( absPathCStr );
}

}
CFRelease( absCFURL );

CFRelease( relCFURL );
CFRelease( relCFStringRef );

#11 - 2015-10-07 11:09 AM - Larry Shaffer
- Assignee set to Larry Shaffer

#12 - 2015-10-07 01:25 PM - Larry Shaffer

Hi John,

Have you verified that the fix you note works for OS X 10.10?

#13 - 2015-10-08 08:46 AM - John Tull

Hi Larry,

No, | don't have the coding skills to apply this to qgis code. | was hoping someone else would come up with a way to implement this workaround and we

could test from there.

#14 - 2015-10-23 02:15 AM - Larry Shaffer
- Status changed from Open to Closed

Fixed in changeset commit:"220affbf9c74391bd13be5173368e3e2e043ccac".
